#pragma once
#include "IAbstractFactory.h"

class IEye;
class INose;
class IMouth;

class CSnowMan
{
public:
	CSnowMan();
	~CSnowMan();

public:
	template < typename FaceFactory >
	void	Create()
	{
		_Create( new FaceFactory );
	}

	void	Print();

private:
	void	_Create( IAbstractFactory* pFactory )
	{
		if( !pFactory )
			return;

		m_pFactory	= pFactory;

		m_pEye		= pFactory->CreateEye();
		m_pNose		= pFactory->CreateNose(); 
		m_pMouth	= pFactory->CreateMouth();
	}
	
private:
	IAbstractFactory* m_pFactory;
	IEye*		m_pEye;
	INose*		m_pNose;
	IMouth*		m_pMouth;
};

